/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the APIDebugResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &APIDebugResponse{}

// APIDebugResponse struct for APIDebugResponse
type APIDebugResponse struct {
	Status   *string         `json:"status,omitempty"`
	Message  *string         `json:"message,omitempty"`
	Started  NullableFloat32 `json:"started,omitempty"`
	Ended    NullableFloat32 `json:"ended,omitempty"`
	Duration NullableString  `json:"duration,omitempty"`
	MemoryMb NullableInt32   `json:"memory_mb,omitempty"`
	Logs     []interface{}   `json:"logs,omitempty"`
}

// NewAPIDebugResponse instantiates a new APIDebugResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAPIDebugResponse() *APIDebugResponse {
	this := APIDebugResponse{}
	return &this
}

// NewAPIDebugResponseWithDefaults instantiates a new APIDebugResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAPIDebugResponseWithDefaults() *APIDebugResponse {
	this := APIDebugResponse{}
	return &this
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *APIDebugResponse) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *APIDebugResponse) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *APIDebugResponse) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *APIDebugResponse) SetStatus(v string) {
	o.Status = &v
}

// GetMessage returns the Message field value if set, zero value otherwise.
func (o *APIDebugResponse) GetMessage() string {
	if o == nil || IsNil(o.Message) {
		var ret string
		return ret
	}
	return *o.Message
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *APIDebugResponse) GetMessageOk() (*string, bool) {
	if o == nil || IsNil(o.Message) {
		return nil, false
	}
	return o.Message, true
}

// HasMessage returns a boolean if a field has been set.
func (o *APIDebugResponse) HasMessage() bool {
	if o != nil && !IsNil(o.Message) {
		return true
	}

	return false
}

// SetMessage gets a reference to the given string and assigns it to the Message field.
func (o *APIDebugResponse) SetMessage(v string) {
	o.Message = &v
}

// GetStarted returns the Started field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *APIDebugResponse) GetStarted() float32 {
	if o == nil || IsNil(o.Started.Get()) {
		var ret float32
		return ret
	}
	return *o.Started.Get()
}

// GetStartedOk returns a tuple with the Started field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *APIDebugResponse) GetStartedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Started.Get(), o.Started.IsSet()
}

// HasStarted returns a boolean if a field has been set.
func (o *APIDebugResponse) HasStarted() bool {
	if o != nil && o.Started.IsSet() {
		return true
	}

	return false
}

// SetStarted gets a reference to the given NullableFloat32 and assigns it to the Started field.
func (o *APIDebugResponse) SetStarted(v float32) {
	o.Started.Set(&v)
}

// SetStartedNil sets the value for Started to be an explicit nil
func (o *APIDebugResponse) SetStartedNil() {
	o.Started.Set(nil)
}

// UnsetStarted ensures that no value is present for Started, not even an explicit nil
func (o *APIDebugResponse) UnsetStarted() {
	o.Started.Unset()
}

// GetEnded returns the Ended field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *APIDebugResponse) GetEnded() float32 {
	if o == nil || IsNil(o.Ended.Get()) {
		var ret float32
		return ret
	}
	return *o.Ended.Get()
}

// GetEndedOk returns a tuple with the Ended field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *APIDebugResponse) GetEndedOk() (*float32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Ended.Get(), o.Ended.IsSet()
}

// HasEnded returns a boolean if a field has been set.
func (o *APIDebugResponse) HasEnded() bool {
	if o != nil && o.Ended.IsSet() {
		return true
	}

	return false
}

// SetEnded gets a reference to the given NullableFloat32 and assigns it to the Ended field.
func (o *APIDebugResponse) SetEnded(v float32) {
	o.Ended.Set(&v)
}

// SetEndedNil sets the value for Ended to be an explicit nil
func (o *APIDebugResponse) SetEndedNil() {
	o.Ended.Set(nil)
}

// UnsetEnded ensures that no value is present for Ended, not even an explicit nil
func (o *APIDebugResponse) UnsetEnded() {
	o.Ended.Unset()
}

// GetDuration returns the Duration field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *APIDebugResponse) GetDuration() string {
	if o == nil || IsNil(o.Duration.Get()) {
		var ret string
		return ret
	}
	return *o.Duration.Get()
}

// GetDurationOk returns a tuple with the Duration field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *APIDebugResponse) GetDurationOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Duration.Get(), o.Duration.IsSet()
}

// HasDuration returns a boolean if a field has been set.
func (o *APIDebugResponse) HasDuration() bool {
	if o != nil && o.Duration.IsSet() {
		return true
	}

	return false
}

// SetDuration gets a reference to the given NullableString and assigns it to the Duration field.
func (o *APIDebugResponse) SetDuration(v string) {
	o.Duration.Set(&v)
}

// SetDurationNil sets the value for Duration to be an explicit nil
func (o *APIDebugResponse) SetDurationNil() {
	o.Duration.Set(nil)
}

// UnsetDuration ensures that no value is present for Duration, not even an explicit nil
func (o *APIDebugResponse) UnsetDuration() {
	o.Duration.Unset()
}

// GetMemoryMb returns the MemoryMb field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *APIDebugResponse) GetMemoryMb() int32 {
	if o == nil || IsNil(o.MemoryMb.Get()) {
		var ret int32
		return ret
	}
	return *o.MemoryMb.Get()
}

// GetMemoryMbOk returns a tuple with the MemoryMb field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *APIDebugResponse) GetMemoryMbOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.MemoryMb.Get(), o.MemoryMb.IsSet()
}

// HasMemoryMb returns a boolean if a field has been set.
func (o *APIDebugResponse) HasMemoryMb() bool {
	if o != nil && o.MemoryMb.IsSet() {
		return true
	}

	return false
}

// SetMemoryMb gets a reference to the given NullableInt32 and assigns it to the MemoryMb field.
func (o *APIDebugResponse) SetMemoryMb(v int32) {
	o.MemoryMb.Set(&v)
}

// SetMemoryMbNil sets the value for MemoryMb to be an explicit nil
func (o *APIDebugResponse) SetMemoryMbNil() {
	o.MemoryMb.Set(nil)
}

// UnsetMemoryMb ensures that no value is present for MemoryMb, not even an explicit nil
func (o *APIDebugResponse) UnsetMemoryMb() {
	o.MemoryMb.Unset()
}

// GetLogs returns the Logs field value if set, zero value otherwise.
func (o *APIDebugResponse) GetLogs() []interface{} {
	if o == nil || IsNil(o.Logs) {
		var ret []interface{}
		return ret
	}
	return o.Logs
}

// GetLogsOk returns a tuple with the Logs field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *APIDebugResponse) GetLogsOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Logs) {
		return nil, false
	}
	return o.Logs, true
}

// HasLogs returns a boolean if a field has been set.
func (o *APIDebugResponse) HasLogs() bool {
	if o != nil && !IsNil(o.Logs) {
		return true
	}

	return false
}

// SetLogs gets a reference to the given []interface{} and assigns it to the Logs field.
func (o *APIDebugResponse) SetLogs(v []interface{}) {
	o.Logs = v
}

func (o APIDebugResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o APIDebugResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.Message) {
		toSerialize["message"] = o.Message
	}
	if o.Started.IsSet() {
		toSerialize["started"] = o.Started.Get()
	}
	if o.Ended.IsSet() {
		toSerialize["ended"] = o.Ended.Get()
	}
	if o.Duration.IsSet() {
		toSerialize["duration"] = o.Duration.Get()
	}
	if o.MemoryMb.IsSet() {
		toSerialize["memory_mb"] = o.MemoryMb.Get()
	}
	if !IsNil(o.Logs) {
		toSerialize["logs"] = o.Logs
	}
	return toSerialize, nil
}

type NullableAPIDebugResponse struct {
	value *APIDebugResponse
	isSet bool
}

func (v NullableAPIDebugResponse) Get() *APIDebugResponse {
	return v.value
}

func (v *NullableAPIDebugResponse) Set(val *APIDebugResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableAPIDebugResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableAPIDebugResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAPIDebugResponse(val *APIDebugResponse) *NullableAPIDebugResponse {
	return &NullableAPIDebugResponse{value: val, isSet: true}
}

func (v NullableAPIDebugResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAPIDebugResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
